/* fss.h  */
#include "interpreter.h"
#include "fss.h"

static int fssPROTvalue    = fssPROT;
static int fssNUMvalue     = fssNUM;
static int fssHIvalue      = fssHI;
static int fssNONvalue     = fssNON;

static int fssBLUEvalue    = fssBLUE;
static int fssREDvalue     = fssRED;
static int fssPINKvalue    = fssPINK;
static int fssGREENvalue   = fssGREEN;
static int fssTURQvalue    = fssTURQ;
static int fssYELLOWvalue  = fssYELLOW;
static int fssWHITEvalue   = fssWHITE;

static int fssBLINKvalue   = fssBLINK;
static int fssREVERSEvalue = fssREVERSE;
static int fssUSCOREvalue  = fssUSCORE;

static int fssENTERvalue   = fssENTER;
static int fssCLEARvalue   = fssCLEAR;
static int fssRESHOWvalue  = fssRESHOW;
static int fssPFK01value   = fssPFK01;
static int fssPFK02value   = fssPFK02;
static int fssPFK03value   = fssPFK03;
static int fssPFK04value   = fssPFK04;
static int fssPFK05value   = fssPFK05;
static int fssPFK06value   = fssPFK06;
static int fssPFK07value   = fssPFK07;
static int fssPFK08value   = fssPFK08;
static int fssPFK09value   = fssPFK09;
static int fssPFK10value   = fssPFK10;
static int fssPFK11value   = fssPFK11;
static int fssPFK12value   = fssPFK12;
static int fssPFK13value   = fssPFK13;
static int fssPFK14value   = fssPFK14;
static int fssPFK15value   = fssPFK15;
static int fssPFK16value   = fssPFK16;
static int fssPFK17value   = fssPFK17;
static int fssPFK18value   = fssPFK18;
static int fssPFK19value   = fssPFK19;
static int fssPFK20value   = fssPFK20;
static int fssPFK21value   = fssPFK21;
static int fssPFK22value   = fssPFK22;
static int fssPFK23value   = fssPFK23;
static int fssPFK24value   = fssPFK24;


void FSS_Init(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssInit();
}

void FSS_Term(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssTerm();
}

void FSS_Reset(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssReset();
}

void FSS_Fld(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssFld(Param[0]->Val->Integer, Param[1]->Val->Integer, 
		                                Param[2]->Val->Integer, Param[3]->Val->Pointer, 
										Param[4]->Val->Integer, Param[5]->Val->Pointer);
}

void FSS_Txt(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssTxt(Param[0]->Val->Integer, Param[1]->Val->Integer, 
		                                Param[2]->Val->Integer, Param[3]->Val->Pointer);
}

void FSS_SetField(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssSetField(Param[0]->Val->Pointer, Param[1]->Val->Pointer);	                                
}

void FSS_GetField(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Pointer = fssGetField(Param[0]->Val->Pointer);	                                
}

void FSS_GetAID(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssGetAID();	                                
}

void FSS_SetCursor(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssSetCursor(Param[0]->Val->Pointer);	                                
}

void FSS_SetAttr(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssSetAttr(Param[0]->Val->Pointer, Param[1]->Val->Integer);	                                
}

void FSS_SetColor(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssSetColor(Param[0]->Val->Pointer, Param[1]->Val->Integer);	                                
}

void FSS_SetXH(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssSetXH(Param[0]->Val->Pointer, Param[1]->Val->Integer);	                                
}

void FSS_Refresh(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssRefresh();
}

void FSS_Trim(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Pointer = fssTrim(Param[0]->Val->Pointer);	                                
}

void FSS_IsBlank(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssIsBlank(Param[0]->Val->Pointer);	                                
}

void FSS_IsNumeric(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssIsNumeric(Param[0]->Val->Pointer);	                                
}

void FSS_IsHex(struct ParseState *Parser, struct Value *ReturnValue, struct Value **Param, int NumArgs)
{
	ReturnValue->Val->Integer = fssIsHex(Param[0]->Val->Pointer);	                                
}


/* all fss.h functions */
struct LibraryFunction FSSFunctions[] =
{
	{ FSS_Init,            "int   fssInit(void);"                },
	{ FSS_Term,            "int   fssTerm(void);"                },
	{ FSS_Reset,           "int   fssReset(void);"               },
	{ FSS_Fld,             "int   fssFld(int, int, int, char *, int, char *);" },
	{ FSS_Txt,             "int   fssTxt(int, int, int, char *);" },
	{ FSS_SetField,        "int   fssSetField(char *, char *);"   },
	{ FSS_GetField,        "char *fssGetField(char *);"           },
	{ FSS_GetAID,          "int   fssGetAID(void);"               },
	{ FSS_SetCursor,       "int   fssSetCursor(char *);"          },
	{ FSS_SetAttr,         "int   fssSetAttr(char *, int);"       },
	{ FSS_SetColor,        "int   fssSetColor(char *, int);"      },
	{ FSS_SetXH,           "int   fssSetXH(char *, int);"         },
	{ FSS_Refresh,         "int   fssRefresh(void);"              },
	{ FSS_Trim,            "char *fssTrim(char *);"               },
	{ FSS_IsNumeric,       "int   fssIsNumeric(char *);"          },
	{ FSS_IsBlank,         "int   fssIsBlank(char *);"            },
	{ FSS_IsHex,           "int   fssIsHex(char *);"              },
    { NULL,             NULL }
};

/* creates various system-dependent definitions */
void FSSSetupFunc(void)
{
	VariableDefinePlatformVar(NULL, "fssPROT",   &IntType, (union AnyValue *) &fssPROTvalue,   FALSE);
	VariableDefinePlatformVar(NULL, "fssNUM",    &IntType, (union AnyValue *) &fssNUMvalue,    FALSE);
	VariableDefinePlatformVar(NULL, "fssHI",     &IntType, (union AnyValue *) &fssHIvalue,     FALSE);
	VariableDefinePlatformVar(NULL, "fssNON",    &IntType, (union AnyValue *) &fssNONvalue,    FALSE);

	VariableDefinePlatformVar(NULL, "fssBLUE",   &IntType, (union AnyValue *) &fssBLUEvalue,   FALSE);
	VariableDefinePlatformVar(NULL, "fssRED",    &IntType, (union AnyValue *) &fssREDvalue,    FALSE);
	VariableDefinePlatformVar(NULL, "fssPINK",   &IntType, (union AnyValue *) &fssPINKvalue,   FALSE);
	VariableDefinePlatformVar(NULL, "fssGREEN",  &IntType, (union AnyValue *) &fssGREENvalue,  FALSE);
	VariableDefinePlatformVar(NULL, "fssTURQ",   &IntType, (union AnyValue *) &fssTURQvalue,   FALSE);
	VariableDefinePlatformVar(NULL, "fssYELLOW", &IntType, (union AnyValue *) &fssYELLOWvalue, FALSE);
	VariableDefinePlatformVar(NULL, "fssWHITE",  &IntType, (union AnyValue *) &fssWHITEvalue,  FALSE);

	VariableDefinePlatformVar(NULL, "fssENTER", &IntType, (union AnyValue *) &fssENTERvalue,   FALSE);
	VariableDefinePlatformVar(NULL, "fssCLEAR", &IntType, (union AnyValue *) &fssCLEARvalue,   FALSE);
    VariableDefinePlatformVar(NULL, "fssRESHOW", &IntType, (union AnyValue *) &fssRESHOWvalue, FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK01", &IntType, (union AnyValue *) &fssPFK01value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK02", &IntType, (union AnyValue *) &fssPFK02value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK03", &IntType, (union AnyValue *) &fssPFK03value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK04", &IntType, (union AnyValue *) &fssPFK04value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK05", &IntType, (union AnyValue *) &fssPFK05value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK06", &IntType, (union AnyValue *) &fssPFK06value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK07", &IntType, (union AnyValue *) &fssPFK07value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK08", &IntType, (union AnyValue *) &fssPFK08value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK09", &IntType, (union AnyValue *) &fssPFK09value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK10", &IntType, (union AnyValue *) &fssPFK10value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK11", &IntType, (union AnyValue *) &fssPFK11value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK12", &IntType, (union AnyValue *) &fssPFK12value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK13", &IntType, (union AnyValue *) &fssPFK13value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK14", &IntType, (union AnyValue *) &fssPFK14value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK15", &IntType, (union AnyValue *) &fssPFK15value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK16", &IntType, (union AnyValue *) &fssPFK16value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK17", &IntType, (union AnyValue *) &fssPFK17value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK18", &IntType, (union AnyValue *) &fssPFK18value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK19", &IntType, (union AnyValue *) &fssPFK19value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK20", &IntType, (union AnyValue *) &fssPFK20value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK21", &IntType, (union AnyValue *) &fssPFK21value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK22", &IntType, (union AnyValue *) &fssPFK22value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK23", &IntType, (union AnyValue *) &fssPFK23value,   FALSE);
	VariableDefinePlatformVar(NULL, "fssPFK24", &IntType, (union AnyValue *) &fssPFK24value,   FALSE);
}

